<template>
  <q-page padding>
    <div class="row q-mb-md" v-show="error">
      <div class="col">
        <q-banner inline-actions class="text-white bg-negative">
          {{ error }}
          <template v-slot:action>
            <q-btn
              flat
              icon="refresh"
              color="white"
              label="Retry"
              :href="`${apiUrl}/google/redirect`"
            />
          </template>
        </q-banner>
      </div>
    </div>
    <div class="row" v-show="error === false">
      <div class="col">
        <q-spinner
          color="primary"
          size="3em"
        />
        <span class="q-ml-md">
          Authenticating...
        </span>
      </div>
    </div>
  </q-page>
</template>

<script lang="ts">
import { defineComponent, Ref, ref } from 'vue';
import { api } from 'src/boot/axios';
import { useRoute, useRouter } from 'vue-router';

export default defineComponent({
  name: 'GoogleCallbackPage',
  setup() {
    const route = useRoute();
    const router = useRouter();
    const error: Ref<string | boolean> = ref(false);
    const apiUrl = ref('');

    api.getApiUrl().then((url) => {
      apiUrl.value = url;
    });

    if (api.isAuthenticated()) {
      router.push({ name: 'home' });
    } else {
      api.authenticate(route.query)
        .then(() => {
          router.push({ name: 'home' });
        })
        .catch((err) => {
          const { response } = err;
          error.value = `Error (${response.status}): ${response.data.error}`;
        });
    }

    return {
      apiUrl,
      error,
    };
  },
});
</script>
